/*
    gcommon
    copyright (c) 1998-2013 Kazuki Iwamoto http://www.maid.org/ iwm@maid.org

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef __GLIBWINDOWS_H__
#define __GLIBWINDOWS_H__


#include "gcommon.h"


G_BEGIN_DECLS


/******************************************************************************
* Windows Compatibility Functions                                             *
******************************************************************************/
#ifdef G_OS_WIN32
# ifndef MAXPATHLEN
#  define MAXPATHLEN 1024
# endif /* not MAXPATHLEN */
# ifndef G_WIN32_HAVE_WIDECHAR_API
#  define G_WIN32_HAVE_WIDECHAR_API() TRUE
# endif /* not G_WIN32_HAVE_WIDECHAR_API */
# ifndef G_WIN32_IS_NT_BASED
#  define G_WIN32_IS_NT_BASED() TRUE
# endif /* not G_WIN32_IS_NT_BASED */


# if ! GLIB_CHECK_VERSION(2,8,0)
gchar *g_win32_locale_filename_from_utf8 (const gchar *utf8filename);
# endif /* not GLIB_CHECK_VERSION(2,8,0) */
#endif /* G_OS_WIN32 */


G_END_DECLS


#endif /* __GLIBWINDOWS_H__ */
